#include <stdio.h>
#include <libspe2.h>
#include <pthread.h>
#include <libmisc.h>
#include <malloc_align.h>

#include "common.h"

#define SPU_TO_RUN  2
#define SPU_P1      3

extern spe_program_handle_t spucode;
//extern spe_program_handle_t ps3spu1;


typedef struct {
    spe_context_ptr_t context;
    void* args;
    void* env;
} run_cmd_t;

#define SIZE 128

float a[SIZE] __attribute__((aligned(128)));
float b[SIZE] __attribute__((aligned(128)));
float c[SIZE] __attribute__((aligned(128)));

void *start_spu_program(void *arg) {

   run_cmd_t run_cmd = *(run_cmd_t *) arg;

   unsigned int entry = SPE_DEFAULT_ENTRY;
   spe_stop_info_t stop_info;

   printf("Prave spoustim SPU s args  %p \n", run_cmd.args);
   spe_context_run(run_cmd.context, &entry, 0, run_cmd.args, run_cmd.env, &stop_info);

   pthread_exit(NULL);
}

int main() {
    printf("Ahoj tady PPU\n");

    int i;
    int rc;
    int flags = 0;

    pthread_t pthread[SPU_TO_RUN];
    spe_context_ptr_t context[SPU_TO_RUN];
    command_t* command[SPU_TO_RUN];
    run_cmd_t  run_cmd[SPU_TO_RUN];

    // napln pole
    for (i=0; i< SIZE; i++){
        a[i] = i;
        b[i] = i+100;
        b[i] = i*1000;
    }
    printf("ppu vec.a: %p\n", a);
    printf("ppu vec.b: %p\n", b);
    printf("ppu vec.c: %p\n", c);


    for(i = 0; i < SPU_TO_RUN; i++) {
        context[i] = spe_context_create(flags, NULL);
        rc = spe_program_load(context[i], &spucode);
    }

    printf("PPU fork\n");
    for(i = 0; i < SPU_TO_RUN; i++) {

        command[i] = (command_t*)_malloc_align(sizeof(command), 7);
        //command[i] = (command_t*)malloc(sizeof(command));

        command[i]->size = SIZE;
        command[i]->a = (uint64_t)a;
        command[i]->b = (uint64_t)b;
        command[i]->c = (uint64_t)c;

        printf("ppu args[%d]: %p\n", i, command[i]);

        run_cmd[i].context = context[i];
        run_cmd[i].args = command[i];
        run_cmd[i].env = NULL;

        //printf("Command ptr: %p\n", command[i]);

        pthread_create(&pthread[i], NULL, &start_spu_program, &run_cmd[i]);
    }

    printf("PPU join\n");
    for(i = 0; i < SPU_TO_RUN; i++) {
        pthread_join(pthread[i], NULL);
    }
    printf("PPU join done\n");

    for(i = 0; i < SPU_TO_RUN; i++) {
        spe_context_destroy(context[i]);
    }
    printf("Ja PPU tady koncim !\n");

    return 0;
}
